/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 3.0.12
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package com.sensory.speech.snsr;

import android.content.Context;
import android.content.res.AssetManager;

/**
 * @file
 * Library, task and version constants and setting keys.
 * @addtogroup java
 * @{
 */
/**
 * Library, task and version constants and setting keys.
 */
public class Snsr {
/**
 * License expiration warning message. Use with SnsrSession#getString.
 * This value is `NULL` for library license keys that do not expire,
 * or if the expiration date is more than 60 days into the future.
 * For license keys expiring in 60 days or fewer, the returned string
 * will be of the form `"License will expire in 37 days."`.
 */
  public final static String LICENSE_WARNING = "license-exp-warn";

/**
 * License expiration date.
 * Example:
 * @code
 * double e;
 * time_t expdate;
 * snsrGetDouble(s, Snsr#LICENSE_EXPDATE, &e);
 * expdate = (time_t)e;
 * @endcode
 * @see SnsrSession#getDouble.
 */
  public final static String LICENSE_EXPDATE = "license-exp-date";

/**
 * License expiration message.
 * The returned string is of the form `"License expires on <date>"`, or
 * `NULL` for license keys that do not expire.
 * Example:
 * @code
 * const char *expires;
 * snsrGetString(s, Snsr#LICENSE_EXPIRES, &expires);
 * if (expires) fprintf(stderr, "%s\n", expires);
 * @endcode
 * @see SnsrSession#getString.
 */
  public final static String LICENSE_EXPIRES = "license-exp-message";

/**
 * SDK library information.
 * Convenient summary of Snsr#NAME, Snsr#VERSION,
 * Snsr#VERSION_DSP, Snsr#LICENSE_EXPIRES and Snsr#LICENSE_WARNING.
 * @note The session handle must be @c NULL.
 *
 * Example:
 * @code
 * const char *libInfo;
 * snsrGetString(NULL, Snsr#LIBRARY_INFO, &libInfo);
 * fprintf(stderr, "%s\n", libInfo);
 * snsrRelease(libInfo);
 * @endcode
 */
  public final static String LIBRARY_INFO = "library-info";

/**
 * Recognition pipeline behavior.
 * This boolean value controls whether SnsrSession#run flushes the recognition
 * pipeline when one (or more) of the input streams report an end-of-file
 * condition.
 *
 * The default value is @c 1, which enables automatic flushing on SnsrRC#EOF.
 * This is appropriate for most applications.
 * Set Snsr#AUTO_FLUSH to @c 0 when audio is presented to SnsrSession#run in small
 * segments.
 *
 * @see SnsrSession#run.
 */
  public final static String AUTO_FLUSH = "auto-flush";

/**
 * Task type key.
 * @see SnsrSession#getString, SnsrSession#require.
 */
  public final static String TASK_TYPE = "task-type";

/**
 * Task name key.
 * @see SnsrSession#getString
 */
  public final static String TASK_NAME = "task-name";

/**
 * Task version key.
 * These strings follow [semantic versioning](http://semver.org/) rules.
 * @see SnsrSession#getString, SnsrSession#require.
 */
  public final static String TASK_VERSION = "task-version";

/**
 * Phrase spotter task type.
 * @see SnsrSession#require.
 */
  public final static String PHRASESPOT = "phrasespot";

/**
 * Phrase spot delay in ms.
 * Delays the phrase spot result while searching for a better match.
 * @see SnsrSession#setInt.
 */
  public final static String SPOT_DELAY = "delay";

/**
 * Phrase spot listening window in seconds.
 * Listening window the phrase spotter is tuned for.
 * `0` for continuous/unbounded listening.
 * @note Information only, does not affect SDK phrase spotter behaviour.
 * Does, however, affect data generated for embedded use.
 * @see SnsrSession#getInt.
 */
  public final static String LISTEN_WINDOW = "listen-window";

/**
 * Embedded device target name.
 * @see SnsrSession#setString.
 */
  public final static String EMBEDDED_TARGET = "dsp-target";

/**
 * Embedded device search header.
 * @see SnsrSession#getStream.
 */
  public final static String EMBEDDED_HEADER_STREAM = "dsp-header-stream";

/**
 * Embedded device search model.
 * @see SnsrSession#getStream.
 */
  public final static String EMBEDDED_SEARCH_STREAM = "dsp-search-stream";

/**
 * Embedded device acoustic model.
 * @see SnsrSession#getStream.
 */
  public final static String EMBEDDED_ACMODEL_STREAM = "dsp-acmodel-stream";

/**
 * Spotter operating point.
 * Selects the trade-off between false accept and false reject errors for
 * fixed-phrase spotters. The operating point was known as the search index
 * in earlier versions of the TrulyHandsfree SDK.
 * - Range is @c 1 to @c 21 inclusive.
 * - Lower-numbered points have a lower false accept rate at the expense
 *   of higher false reject fraction.
 * - The false accept rate is expressed as the expected number of false accepts
 *   (where the recognizer mistakenly spots the trigger phrase) per time unit.
 * - The false reject rate is the percentage of times the actual trigger phrase
 *   is spoken, but not recognized.
 * - The default operating point is selected by Sensory during trigger
 *   development for a good balance between the these two error types.
 * - Note that not all operating points are necessarily valid. Use
 *   Snsr#OPERATING_POINT_LIST to iterate over the available points.
 * @see SnsrSession#getInt, SnsrSession#setInt, Snsr#OPERATING_POINT_LIST.
 */
  public final static String OPERATING_POINT = "operating-point";

/**
 * Iterate over available spotter operating points.
 * @see SnsrSession#forEach, Snsr#RES_AVAILABLE_POINT.
 */
  public final static String OPERATING_POINT_LIST = "operating-point-iterator";

/**
 * Available operating point.
 * This read-only value is valid during Snsr#OPERATING_POINT_LIST
 * iteration callbacks only.
 * @see SnsrSession#getInt, Snsr#OPERATING_POINT_LIST, Snsr#OPERATING_POINT.
 */
  public final static String RES_AVAILABLE_POINT = "available-point";

/**
 * Sample rate in Hz.
 * Read-only.
 * @see SnsrSession#getInt.
 */
  public final static String SAMPLE_RATE = "samples-per-second";

/**
 * Input audio buffer size.
 * The number of audio samples kept in a circular audio history buffer,
 * accessible through Snsr#AUDIO_STREAM.
 *
 * This buffer can be used to retrieve segmented audio using alignments
 * (Snsr#RES_BEGIN_SAMPLE, Snsr#RES_END_SAMPLE) obtained in the
 * Snsr#RESULT_EVENT callback.
 *
 * Set to `0` to disable audio buffering.
 * @see SnsrSession#getInt, SnsrSession#setInt.
 */
  public final static String AUDIO_STREAM_SIZE = "audio-stream-size";

/**
 * Audio buffer start sample index.
 * The index of the first (oldest) audio sample contained in the
 * Snsr#AUDIO_STREAM.
 * @see SnsrSession#getDouble, SnsrSession#setDouble.
 */
  public final static String AUDIO_STREAM_FIRST = "audio-stream-first";

/**
 * Audio buffer end sample index.
 * The index of the last (most recent) audio sample contained in the
 * Snsr#AUDIO_STREAM.
 * @see SnsrSession#getDouble, SnsrSession#setDouble.
 */
  public final static String AUDIO_STREAM_LAST = "audio-stream-last";

/**
 * Audio stream requested start index.
 * Start the next Snsr#AUDIO_STREAM at this sample index value.
 * Defaults to Snsr#AUDIO_STREAM_FIRST.
 * @see SnsrSession#getDouble, SnsrSession#setDouble.
 */
  public final static String AUDIO_STREAM_FROM = "audio-stream-from";

/**
 * Audio stream requested end index.
 * End the next Snsr#AUDIO_STREAM at this sample index value.
 * Defaults to Snsr#AUDIO_STREAM_LAST.
 * @see SnsrSession#getDouble, SnsrSession#setDouble.
 */
  public final static String AUDIO_STREAM_TO = "audio-stream-to";

/**
 * Source audio stream.
 * This audio stream must be headerless, 16-bit PCM encoded and sampled
 * at 16 kHz.
 * @see SnsrSession#setStream.
 */
  public final static String SOURCE_AUDIO_PCM = "->audio-pcm";

/**
 * Sequential task has started listening on second slot.
 * Raised in a sequential task when audio focust has shifted from the
 * first slot to the second. This typically happens when the spotter
 * in the first slot has detected the phrase.
 *
 * This event is ignored for tasks that do not feature sequential behavior.
 *
 * @see SnsrSession#setHandler, Snsr#LISTEN_END_EVENT
 */
  public final static String LISTEN_BEGIN_EVENT = "^listen-begin";

/**
 * Sequential task has stopped listening on second slot.
 * Raised in a sequential task when audio focus has shifted from the second slot
 * back to the first.
 *
 * This event is ignored for tasks that do not feature sequential behavior.
 *
 * @see SnsrSession#setHandler, Snsr#LISTEN_BEGIN_EVENT, Snsr#LISTEN_WINDOW
 */
  public final static String LISTEN_END_EVENT = "^listen-end";

/**
 * Result available event.
 * Raised when a phrase has been spotted, and the speaker verification score
 * is above threshold.
 */
  public final static String RESULT_EVENT = "^result";

/**
 * Samples available event.
 * Raised whenever audio samples have been read from the input stream and
 * are about to be processed.
 * @see SnsrSession#setHandler.
 */
  public final static String SAMPLES_EVENT = "^sample-count";

/**
 * Number of samples read from the input stream.
 * The range of this value is limited to that of the native
 * @c size_t type. On 32-bit architectures the sample count value will
 * typically wrap to zero after 2**32 samples.
 * @see SnsrSession#getDouble, Snsr#SAMPLES_EVENT
 */
  public final static String RES_SAMPLES = "sample-count";

/**
 * Timestamp of the audio start point.
 * The offset in ms from the beginning of the audio stream where:
 * - the recognition unit started, or
 * - the Voice Activity Detector first detected speech.
 * @see SnsrSession#getDouble.
 */
  public final static String RES_BEGIN_MS = "begin-ms";

/**
 * Sample index of the audio start point.
 * The offset in samples from the beginning of the audio stream where:
 * - the recognition unit started, or
 * - the Voice Activity Detector first detected speech.
 * @see SnsrSession#getDouble.
 */
  public final static String RES_BEGIN_SAMPLE = "begin-sample";

/**
 * Timestamp of the audio endpoint.
 * The offset in ms from the beginning of the audio stream:
 * - where the recognition unit ended, or
 * - the Voice Activity Detector last detected speech.
 * @see SnsrSession#getDouble.
 */
  public final static String RES_END_MS = "end-ms";

/**
 *  Sample index of the audio endpoint.
 * The offset in samples from the beginning of the audio stream:
 * - where the recognition unit ended, or
 * - the Voice Activity Detector last detected speech.
 * @see SnsrSession#getDouble.
 */
  public final static String RES_END_SAMPLE = "end-sample";

/**
 * Fixed-phrase confidence score.
 * The confidence that the spotted phrase was actually spoken.
 * This is a model-dependent optional feature not universally supported. It
 * is not supported by enrolled models (use Snsr#RES_SV_SCORE instead.)
 *
 * @note This value is defined at the Snsr#PHRASE_LIST level only.
 *
 * The reported range is @c 0 to @c 1, or @c < @c 0
 * if not supported by the spotter model.
 * @see SnsrSession#getDouble
 */
  public final static String RES_CONF_SCORE = "confidence-score";

/**
 * Speaker verification score.
 * The confidence that the spotted phrase was spoken by the enrolled speaker, in
 * the range @c 0 to @c 1. For non-enrolled spotters the confidence
 * is always @c 1.0.
 * @see SnsrSession#getDouble, Snsr#SV_THRESHOLD
 */
  public final static String RES_SV_SCORE = "sv-score";

/**
 * Speaker verification threshold.
 * Phrase spot results with a Snsr#RES_SV_SCORE less than this threshold are
 * not reported (the Snsr#RESULT_EVENT handler will not be invoked.)
 * @see SnsrSession#getDouble, SnsrSession#setDouble, Snsr#RES_SV_SCORE
 */
  public final static String SV_THRESHOLD = "sv-threshold";

/**
 * Signal energy.
 * The energy (in dB relative to @c 1) in the spotted phrase.
 *
 * @see SnsrSession#getDouble, Snsr#RES_NOISE_ENERGY, Snsr#RES_SNR
 */
  public final static String RES_SIGNAL_ENERGY = "signal-energy";

/**
 * Noise energy.
 * The energy (in dB relative to @c 1) in the background audio preceding
 * the spotted phrase.
 *
 * @see SnsrSession#getDouble, Snsr#RES_SIGNAL_ENERGY, Snsr#RES_SNR
 */
  public final static String RES_NOISE_ENERGY = "noise-energy";

/**
 * Signal to noise ratio.
 * The ratio of the signal energy to the noise energy, in dB.
 *
 * @see SnsrSession#getDouble, Snsr#RES_NOISE_ENERGY, Snsr#RES_SIGNAL_ENERGY
 */
  public final static String RES_SNR = "snr";

/**
 * **RESERVED**. Do not use.
 * @see SnsrSession#setDouble.
 */
  public final static String SCORE_OFFSET = "score-offset";

/**
 * Recognition text result.
 * The phrase, word, or phoneme result of a phrase spot.
 * @see SnsrSession#getString
 */
  public final static String RES_TEXT = "text";

/**
 * Iterate over phrase results.
 * For phrase spotters there is a single result phrase.
 * @see SnsrSession#forEach.
 */
  public final static String PHRASE_LIST = "phrase-iterator";

/**
 * Iterate over the words in a result.
 * User-defined enrolled results are modeled as a single word.
 * @see SnsrSession#forEach.
 */
  public final static String WORD_LIST = "word-iterator";

/**
 * Iterate over the phonemes in a result.
 * @see SnsrSession#forEach.
 */
  public final static String PHONE_LIST = "phone-iterator";

/**
 * Iterate over the phoneme parts in a result.
 * @see SnsrSession#forEach.
 */
  public final static String MODEL_LIST = "model-iterator";

/**
 * Phrase spotter enrollment task type.
 * @see SnsrSession#require
 */
  public final static String ENROLL = "enroll";

/**
 * Enrollment accuracy.
 * Trades accuracy of the enrolled model for enrollment speed.
 * The default accuracy is @c 1.0, for the best accuracy at the slowest
 * enrollment speed. Valid range is @c 0.0 to @c 1.0.
 * @see SnsrSession#setDouble.
 */
  public final static String ACCURACY = "accuracy";

/**
 * Interactive enrollment mode.
 * This changes the enrollment task behavior: When set to @c 0, enrollment
 * for the current phrase will continue until the end of the stream.
 * @see SnsrSession#setInt.
 */
  public final static String INTERACTIVE_MODE = "interactive";

/**
 * Enrolling user tag.
 * Sets the tag for the current enrollment. This should be a unique
 * alphanumeric phrase, without spaces. It is the phrase returned
 * as a recognition result.
 * @see SnsrSession#getString, SnsrSession#setString, Snsr#USER_LIST
 */
  public final static String USER = "user";

/**
 * Delete an enrolled user.
 * Deletes the named enrollment.
 * @see SnsrSession#setString.
 */
  public final static String DELETE_USER = "delete-user";

/**
 * Force re-adaptation of all enrollments.
 * If all users in an enrollment task have been adapted, the adaptation
 * step is skipped. This is the case when one or more adapted enrollment
 * contexts are loaded, and no new users are added.
 *
 * Setting Snsr#RE_ADAPT to @c 1 changes this behavior to always do the
 * adaptation step.
 * @see SnsrSession#setInt, Snsr#ADAPTED_EVENT
 */
  public final static String RE_ADAPT = "re-adapt";

/**
 * Enrollment progress.
 * A value between @c 0 and @c 100 that is an estimate of the enrollment
 * task completion progress.
 * @see SnsrSession#getDouble.
 */
  public final static String RES_PERCENT_DONE = "percent-done";

/**
 * Reason for enrollment failure.
 * Provides a shorthand indication of why the enrollment was rejected.
 * @see SnsrSession#getString, Snsr#RES_GUIDANCE.
 */
  public final static String RES_REASON = "reason";

/**
 * End-user guidance to correct enrollment failure.
 * Provides a human-readable string (in English) with a suggestion on
 * how to correct an enrollment failure.
 * @see SnsrSession#getString
 */
  public final static String RES_GUIDANCE = "reason-guidance";

/**
 * Enrollment success.
 * @p 1 if the enrollment passed, @p 0 if it was rejected.
 * @see SnsrSession#getInt
 */
  public final static String RES_REASON_PASS = "reason-pass";

/**
 * Enrollment check failure value.
 * The value of a enrollment check parameter. This is compared
 * to Snsr#RES_REASON_THRESHOLD to determine Snsr#RES_REASON_PASS.
 * @see SnsrSession#getDouble
 */
  public final static String RES_REASON_VALUE = "reason-value";

/**
 * Enrollment check threshold value.
 * @see SnsrSession#getDouble, Snsr#RES_REASON_VALUE
 */
  public final static String RES_REASON_THRESHOLD = "reason-threshold";

/**
 * Enrollment count.
 * The number of enrollments accumulated for the enrolled user.
 * @see SnsrSession#getInt, Snsr#USER_LIST, Snsr#ENROLLMENT_TARGET
 */
  public final static String RES_ENROLLMENT_COUNT = "enrollment-count";

/**
 * Enrollment ID.
 * A unique ID for the current user's current enrollment.
 * @see SnsrSession#getInt, Snsr#ENROLLMENT_LIST.
 */
  public final static String RES_ENROLLMENT_ID = "enrollment-id";

/**
 * Enrollment target.
 * The recommended number of enrollments for each user. Using either more or
 * fewer enrollments will reduce overall spotter performance.
 * @see SnsrSession#getInt, Snsr#USER_LIST, Snsr#RES_ENROLLMENT_COUNT
 */
  public final static String ENROLLMENT_TARGET = "req-enroll";

/**
 * Number of enrollments with trailing context.
 * The recommended number of enrollments where the phrase is followed by
 * additional speech. For example: "Hey Sensory will it rain tomorrow?"
 * @see SnsrSession#getInt
 */
  public final static String ENROLLMENT_CONTEXT = "ctx-enroll";

/**
 * The index of the sub-task to enroll.
 * For enrollment tasks that contain multiple sub-tasks (for example,
 * a user-defined trigger and an enrolled fixed trigger), this integer
 * value selects which of the sub-tasks the enrollments should be applied to.
 *
 * See the documentation delivered with the task file for the sub-task mapping.
 *
 * @note For most enrollment tasks the only supported task index is @c 0.
 */
  public final static String ENROLLMENT_TASK_INDEX = "enrollment-task-index";

/**
 * Current enrollment includes trailing context.
 * Set to `1` if the enrollment recording should include trailing context,
 * for example: "Hey Sensory will it rain tomorrow?"
 * @see SnsrSession#getInt, Snsr#RESUME_EVENT
 */
  public final static String ADD_CONTEXT = "add-context";

/**
 * Include enrollment audio in enrollment context.
 * Set to @c 1 to include the enrollment audio in enrollment contexts.
 * @see SnsrSession#setInt, SnsrDataFormat#RUNTIME
 */
  public final static String SAVE_ENROLLMENT_AUDIO = "save-enroll-audio";

/**
 * Enrolled model stream.
 * The result after enrollment and adaptation. This is a model that will
 * recognize the enrolled phrases. Save to permanent storage with
 * SnsrStream#copy.
 * @see SnsrSession#getStream, SnsrStream#copy
 */
  public final static String MODEL_STREAM = "model-stream";

/**
 * Segmented input audio.
 * - For enrollment tasks with Snsr#SAVE_ENROLLMENT_AUDIO is set to @c 1 (on)
 *   this is the enrollment recording. If Snsr#SAVE_ENROLLMENT_AUDIO
 *   is @c 0 (off), audio will only be available in the Snsr#FAIL_EVENT.
 * - For phrase spotter tasks, the samples from Snsr#AUDIO_STREAM_FROM to
 *   Snsr#AUDIO_STREAM_TO selected from the last
 *   Snsr#AUDIO_STREAM_SIZE samples processed by the recognizer.
 *   The default Snsr#AUDIO_STREAM_SIZE is @c 0, which disables audio
 *   buffering and will cause Snsr#AUDIO_STREAM stream retrieval to fail.
 *   Be sure to set Snsr#AUDIO_STREAM_SIZE to the expected number of
 *   samples before calling SnsrSession#run.
 *
 * @see SnsrSession#getStream.
 */
  public final static String AUDIO_STREAM = "audio-stream";

/**
 * Adaptation complete event.
 * Handler called when adaptation has completed and
 * the Snsr#MODEL_STREAM model is available.
 * This handler typically returns SnsrRC#STOP to end SnsrSession#run processing.
 * @see SnsrSession#setHandler
 */
  public final static String DONE_EVENT = "^done";

/**
 * Enrollment complete event.
 * Handler called when enrollment is complete, just before
 * model adaptation starts. Use this handler for the earliest possible
 * access to the enrollment context.
 * @see SnsrSession#setHandler
 */
  public final static String ENROLLED_EVENT = "^enrolled";

/**
 * Adaptation complete event.
 * Handler called when the adaptation of an enrollment is complete,
 * Use this handler for access to the adapted enrollment context.
 * @see SnsrSession#setHandler
 */
  public final static String ADAPTED_EVENT = "^adapted";

/**
 * Enrollment failed event.
 * Handler called if an enrollment fails quailty checks.
 * @see SnsrSession#setHandler
 */
  public final static String FAIL_EVENT = "^fail";

/**
 * Enrollment succeeded event.
 * Handler called when an enrollment passes quality checks.
 * @see SnsrSession#setHandler
 */
  public final static String PASS_EVENT = "^pass";

/**
 * Next user event.
 * Handler called during interactive enrollment to prompt the end-user
 * for a new enrollment phrase.
 * This handler should set Snsr#USER to the tag associated with the new
 * user. Leave Snsr#USER unchanged if there are no more users or phrases
 * to enroll.
 * @see SnsrSession#setHandler
 */
  public final static String NEXT_EVENT = "^next";

/**
 * Input stream pause event.
 * Handler called when a time-consuming processing step is about to start.
 * Use this handler to pause the input stream when doing interactive enrollment.
 * @see SnsrSession#setHandler
 */
  public final static String PAUSE_EVENT = "^pause";

/**
 * Adaptation progress event.
 * Handler called to report adaptation progress.
 * @see SnsrSession#setHandler, Snsr#RES_PERCENT_DONE
 */
  public final static String PROG_EVENT = "^progress";

/**
 * Input stream resume event.
 * Handler called when a time-consuming processing step has completed.
 * Use this handler to restart an input stream that was stopped during
 * a Snsr#PAUSE_EVENT handler.
 * @see SnsrSession#setHandler
 */
  public final static String RESUME_EVENT = "^resume";

/**
 * Iterate over all enrollments for the current user.
 * This can be used to retrieve enrollment audio, when
 * Snsr#SAVE_ENROLLMENT_AUDIO is enabled.
 * @see SnsrSession#forEach, Snsr#USER, Snsr#USER_LIST, Snsr#SAVE_ENROLLMENT_AUDIO
 */
  public final static String ENROLLMENT_LIST = "enrollment-iterator";

/**
 * Iterate over all reasons for enrollment failure.
 * @see SnsrSession#forEach
 */
  public final static String REASON_LIST = "reason-iterator";

/**
 * Iterate over all enrolled users.
 * Sets Snsr#USER to each of the enrolled users before invoking the
 * callback.
 * @see SnsrSession#forEach, Snsr#USER
 */
  public final static String USER_LIST = "user-iterator";

/**
 * VAD task type.
 * @see SnsrSession#require
 */
  public final static String VAD = "vad";

/**
 * Output audio stream.
 * Headerless audio output, 16-bit PCM encoded and sampled at 16 kHz.
 * @see SnsrSession#setStream.
 */
  public final static String SINK_AUDIO_PCM = "<-audio-pcm";

/**
 * Start point back-off in ms.
 * Audio margin added before the start point found by a Voice Activity Detector.
 *
 * @see SnsrSession#setInt, Snsr#RES_BEGIN_MS, Snsr#RES_BEGIN_SAMPLE.
 */
  public final static String BACKOFF = "backoff";

/**
 * Endpoint hold-over.
 * Audio margin added after the endpoint found by a Voice Activity Detector.
 * This is the amount of trailing silence to include in the segmentation.
 *
 * @see SnsrSession#setInt, Snsr#RES_END_MS, Snsr#RES_END_SAMPLE.
 */
  public final static String HOLD_OVER = "hold-over";

/**
 * Include leading silence in VAD output.
 * Set to @c 1 to include all audio up to the endpoint in the
 * Snsr#SINK_AUDIO_PCM output stream. Set to @c 0 to return to the
 * default behavior, which discards leading silence.
 *
 * @see SnsrSession#setInt, Snsr#SINK_AUDIO_PCM, Snsr#PASS_THROUGH.
 */
  public final static String INCLUDE_LEADING_SILENCE = "include-leading-silence";

/**
 * VAD leading silence time-out, in ms.
 * The Voice Activity Detector will invoke the Snsr#SILENCE_EVENT handler
 * if no speech is detected during the first Snsr#LEADING_SILENCE ms of
 * processed audio.
 *
 * @see SnsrSession#setInt, Snsr#TRAILING_SILENCE, Snsr#SILENCE_EVENT.
 */
  public final static String LEADING_SILENCE = "leading-silence";

/**
 * VAD maximum record duration, in ms.
 * The Voice Activity Detector will invoke the Snsr#LIMIT_EVENT handler
 * if the detected speech segment exceeds this value.
 *
 * @see SnsrSession#setInt, Snsr#LIMIT_EVENT.
 */
  public final static String MAX_RECORDING = "max-recording";

/**
 * VAD audio pass-through behaviour.
 * If set to @c 0, no audio from Snsr#SOURCE_AUDIO_PCM will be passed
 * through to Snsr#SINK_AUDIO_PCM. The begin- and endpoint handlers will
 * still be invoked. The default value (@c 1) passes speech-detected samples
 * to Snsr#SINK_AUDIO_PCM.
 *
 * @see SnsrSession#setInt, Snsr#INCLUDE_LEADING_SILENCE.
 */
  public final static String PASS_THROUGH = "pass-through";

/**
 * VAD trailing silence time-out, in ms.
 * The Voice Activity Detector will invoke the Snsr#DONE_EVENT handler
 * once Snsr#TRAILING_SILENCE of ms has followed the last bit of speech.
 *
 * @see SnsrSession#setInt, Snsr#LEADING_SILENCE, Snsr#END_EVENT, Snsr#HOLD_OVER.
 */
  public final static String TRAILING_SILENCE = "trailing-silence";

/**
 * VAD initial ignore duration, in ms.
 * Ignore the first Snsr#SKIP_TO_MS ms of the Snsr#SOURCE_AUDIO_PCM input
 * stream. Use this runtime setting to skip over a trigger phrase included
 * in the source audio. The default is to process all audio.
 *
 * @see SnsrSession#setDouble, Snsr#SKIP_TO_SAMPLE.
 */
  public final static String SKIP_TO_MS = "skip-to-ms";

/**
 * VAD initial ignore duration, in samples.
 * Ignore the first Snsr#SKIP_TO_SAMPLE samples of the Snsr#SOURCE_AUDIO_PCM
 * input stream. Use this runtime setting to skip over a trigger phrase included
 * in the source audio. The default is to process all audio.
 *
 * @see SnsrSession#setDouble, Snsr#SKIP_TO_MS.
 */
  public final static String SKIP_TO_SAMPLE = "skip-to-sample";

/**
 * Begin point detected VAD event.
 * Raised when speech has been detected. Use Snsr#RES_BEGIN_MS or
 * Snsr#RES_BEGIN_SAMPLE to retrieve the start point relative to the beginning
 * of Snsr#SOURCE_AUDIO_PCM.
 *
 * @see SnsrSession#setHandler, Snsr#BACKOFF.
 */
  public final static String BEGIN_EVENT = "^begin";

/**
 * Endpoint detected VAD event.
 * Raised Snsr#TRAILING_SILENCE ms after end-of-speech has been detected.
 * Use Snsr#RES_END_MS or Snsr#RES_END_SAMPLE to retrieve the endpoint
 * relative to the beginning of Snsr#SOURCE_AUDIO_PCM.
 *
 * @see SnsrSession#setHandler, Snsr#HOLD_OVER, Snsr#TRAILING_SILENCE.
 */
  public final static String END_EVENT = "^end";

/**
 * Maxium recording reached VAD event.
 * Raised when Snsr#MAX_RECORDING ms of speech has been processed by the
 * Voice Activity Detector before a trailing-silence endpoint is found.
 * Use Snsr#RES_END_MS or Snsr#RES_END_SAMPLE to retrieve the endpoint
 * relative to the beginning of Snsr#SOURCE_AUDIO_PCM.
 *
 * @see SnsrSession#setHandler, Snsr#HOLD_OVER, Snsr#MAX_RECORDING.
 */
  public final static String LIMIT_EVENT = "^limit";

/**
 * No speech detected event.
 * Raised if no speech is detected within Snsr#LEADING_SILENCE ms from the
 * start of Snsr#SOURCE_AUDIO_PCM (adjusted by Snsr#SKIP_TO_MS or
 * Snsr#SKIP_TO_SAMPLE).
 *
 * @see SnsrSession#setHandler, Snsr#LEADING_SILENCE.
 */
  public final static String SILENCE_EVENT = "^silence";

/**
 * Template slot 0.
 * The first phrase spotter slot in a template task.
 * @see SnsrSession#setStream.
 */
  public final static String SLOT_0 = "0.";

/**
 * Template slot 1.
 * The second phrase spotter slot in a template task.
 * @see SnsrSession#setStream.
 */
  public final static String SLOT_1 = "1.";

/**
 * Phrase Spotter VAD task type.
 * @see SnsrSession#require
 */
  public final static String PHRASESPOT_VAD = "phrasespot-vad";

/** SDK variant name. */
  public final static String NAME = "TrulyHandsfree";

/** API version. Follows [semantic versioning](http://semver.org/) rules. */
  public final static String VERSION = "5.0.0-beta.14";

/** API major version number. Incremented for API changes that are
 *  **not** backwards-compatible. */
  public final static int VERSION_MAJOR = 5;

/** API minor version number. Incremented for changes and improvements that
 *  **are** backwards-compatible. */
  public final static int VERSION_MINOR = 0;

/** API patch version number. Incremented for bug fixes. */
  public final static int VERSION_PATCH = 0;

/** Pre-release version tag. This is empty for official releases. */
  public final static String VERSION_PRE = "beta.14";

/** Build information. This is empty for official releases. */
  public final static String VERSION_BUILD = "\0";

/** Unique release version counter. */
  public final static int VERSION_ID = 27;

/** DSP embedded library version. */
  public final static String VERSION_DSP = "4.4.0";

/** Technology level. Referred to in marketing documentation. */
  public final static String TECH_LEVEL = "5.0";



   private static AssetManager sAssetManager = null;

   /**
    * Initializes the library.
    * Saves the application context handle. This is used by
    * SnsrStream::fromAsset().
    * @note Available on Android SDKs only.
    * @param ctx Android application [Context][1] handle.
    * [1]: https://developer.android.com/reference/android/content/Context.html
    */
   public static void init(Context ctx) {
     sAssetManager = ctx.getApplicationContext().getAssets();
     setAssetManager(sAssetManager); // For JNI stream access.
   }

  public static SWIGTYPE_p_SnsrCallback_ snsrCallback(SWIGTYPE_p_f_p_struct_SnsrSession__p_q_const__char_p_void__SnsrRC h, SWIGTYPE_p_f_p_q_const__void__void r, SWIGTYPE_p_void data) {
    long cPtr = SnsrJNI.snsrCallback(SWIGTYPE_p_f_p_struct_SnsrSession__p_q_const__char_p_void__SnsrRC.getCPtr(h), SWIGTYPE_p_f_p_q_const__void__void.getCPtr(r), SWIGTYPE_p_void.getCPtr(data));
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrCallback_(cPtr, false);
  }

  public static int snsrStreamAtEnd(SWIGTYPE_p_SnsrStream_ b) {
    return SnsrJNI.snsrStreamAtEnd(SWIGTYPE_p_SnsrStream_.getCPtr(b));
  }

  public static SnsrRC snsrStreamClose(SWIGTYPE_p_SnsrStream_ b) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrStreamClose(SWIGTYPE_p_SnsrStream_.getCPtr(b)));
  }

  public static long snsrStreamCopy(SWIGTYPE_p_SnsrStream_ dst, SWIGTYPE_p_SnsrStream_ src, long sizeInBytes) {
    return SnsrJNI.snsrStreamCopy(SWIGTYPE_p_SnsrStream_.getCPtr(dst), SWIGTYPE_p_SnsrStream_.getCPtr(src), sizeInBytes);
  }

  public static String snsrStreamErrorDetail(SWIGTYPE_p_SnsrStream_ b) {
    return SnsrJNI.snsrStreamErrorDetail(SWIGTYPE_p_SnsrStream_.getCPtr(b));
  }

  public static long snsrStreamGetDelim(SWIGTYPE_p_SnsrStream_ b, byte[] buffer, int delim) {
    return SnsrJNI.snsrStreamGetDelim(SWIGTYPE_p_SnsrStream_.getCPtr(b), buffer, delim);
  }

  public static long snsrStreamGetMeta(SWIGTYPE_p_SnsrStream_ b, SnsrStreamMeta key) {
    return SnsrJNI.snsrStreamGetMeta(SWIGTYPE_p_SnsrStream_.getCPtr(b), key.swigValue());
  }

  public static SnsrRC snsrStreamOpen(SWIGTYPE_p_SnsrStream_ b) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrStreamOpen(SWIGTYPE_p_SnsrStream_.getCPtr(b)));
  }

  public static long snsrStreamPrint(SWIGTYPE_p_SnsrStream_ b, String format) {
    return SnsrJNI.snsrStreamPrint(SWIGTYPE_p_SnsrStream_.getCPtr(b), format);
  }

  public static SnsrRC snsrStreamRC(SWIGTYPE_p_SnsrStream_ b) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrStreamRC(SWIGTYPE_p_SnsrStream_.getCPtr(b)));
  }

  public static long snsrStreamRead(SWIGTYPE_p_SnsrStream_ a, SWIGTYPE_p_void buffer, long size, long nitems) {
    return SnsrJNI.snsrStreamRead(SWIGTYPE_p_SnsrStream_.getCPtr(a), SWIGTYPE_p_void.getCPtr(buffer), size, nitems);
  }

  public static long snsrStreamSkip(SWIGTYPE_p_SnsrStream_ a, long size, long nitems) {
    return SnsrJNI.snsrStreamSkip(SWIGTYPE_p_SnsrStream_.getCPtr(a), size, nitems);
  }

  public static long snsrStreamWrite(SWIGTYPE_p_SnsrStream_ a, SWIGTYPE_p_void buffer, long size, long nitems) {
    return SnsrJNI.snsrStreamWrite(SWIGTYPE_p_SnsrStream_.getCPtr(a), SWIGTYPE_p_void.getCPtr(buffer), size, nitems);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromFILE(SWIGTYPE_p_FILE handle, SnsrStreamMode mode) {
    long cPtr = SnsrJNI.snsrStreamFromFILE(SWIGTYPE_p_FILE.getCPtr(handle), mode.swigValue());
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromFileName(String filename, String mode) {
    long cPtr = SnsrJNI.snsrStreamFromFileName(filename, mode);
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromAudioDevice(SnsrStreamAudioFormat format) {
    long cPtr = SnsrJNI.snsrStreamFromAudioDevice(format.swigValue());
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromAudioStream(SWIGTYPE_p_SnsrStream_ a, SnsrStreamAudioFormat format) {
    long cPtr = SnsrJNI.snsrStreamFromAudioStream(SWIGTYPE_p_SnsrStream_.getCPtr(a), format.swigValue());
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromBuffer(long initialSizeInBytes, long maxSizeInBytes) {
    long cPtr = SnsrJNI.snsrStreamFromBuffer(initialSizeInBytes, maxSizeInBytes);
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromMemory(byte[] buffer, SnsrStreamMode mode) {
    long cPtr = SnsrJNI.snsrStreamFromMemory(buffer, mode.swigValue());
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromOpenStream(SWIGTYPE_p_SnsrStream_ source, long sizeInBytes) {
    long cPtr = SnsrJNI.snsrStreamFromOpenStream(SWIGTYPE_p_SnsrStream_.getCPtr(source), sizeInBytes);
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromStreams(SWIGTYPE_p_SnsrStream_ a, SWIGTYPE_p_SnsrStream_ b) {
    long cPtr = SnsrJNI.snsrStreamFromStreams(SWIGTYPE_p_SnsrStream_.getCPtr(a), SWIGTYPE_p_SnsrStream_.getCPtr(b));
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamFromString(String string) {
    long cPtr = SnsrJNI.snsrStreamFromString(string);
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStreamRaise(SWIGTYPE_p_f_p_struct_SnsrStream__p_void__SnsrRC e, SWIGTYPE_p_f_p_q_const__void__void r, SWIGTYPE_p_void data) {
    long cPtr = SnsrJNI.snsrStreamRaise(SWIGTYPE_p_f_p_struct_SnsrStream__p_void__SnsrRC.getCPtr(e), SWIGTYPE_p_f_p_q_const__void__void.getCPtr(r), SWIGTYPE_p_void.getCPtr(data));
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_ snsrStream_alloc(SWIGTYPE_p_SnsrStream_Vmt def, SWIGTYPE_p_void data, int readable, int writable) {
    long cPtr = SnsrJNI.snsrStream_alloc(SWIGTYPE_p_SnsrStream_Vmt.getCPtr(def), SWIGTYPE_p_void.getCPtr(data), readable, writable);
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_(cPtr, false);
  }

  public static SWIGTYPE_p_void snsrStream_getData(SWIGTYPE_p_SnsrStream_ b) {
    long cPtr = SnsrJNI.snsrStream_getData(SWIGTYPE_p_SnsrStream_.getCPtr(b));
    return (cPtr == 0) ? null : new SWIGTYPE_p_void(cPtr, false);
  }

  public static SWIGTYPE_p_SnsrStream_Vmt snsrStream_getVmt(SWIGTYPE_p_SnsrStream_ b) {
    long cPtr = SnsrJNI.snsrStream_getVmt(SWIGTYPE_p_SnsrStream_.getCPtr(b));
    return (cPtr == 0) ? null : new SWIGTYPE_p_SnsrStream_Vmt(cPtr, false);
  }

  public static void snsrStream_setRC(SWIGTYPE_p_SnsrStream_ h, SnsrRC code) {
    SnsrJNI.snsrStream_setRC(SWIGTYPE_p_SnsrStream_.getCPtr(h), code.swigValue());
  }

  public static void snsrStream_setDetail(SWIGTYPE_p_SnsrStream_ b, String format) {
    SnsrJNI.snsrStream_setDetail(SWIGTYPE_p_SnsrStream_.getCPtr(b), format);
  }

  public static void snsrClearRC(SWIGTYPE_p_SnsrSession_ s) {
    SnsrJNI.snsrClearRC(SWIGTYPE_p_SnsrSession_.getCPtr(s));
  }

  public static void snsrDescribeError(SWIGTYPE_p_SnsrSession_ s, String format) {
    SnsrJNI.snsrDescribeError(SWIGTYPE_p_SnsrSession_.getCPtr(s), format);
  }

  public static SnsrRC snsrDup(SWIGTYPE_p_SnsrSession_ s, SWIGTYPE_p_p_SnsrSession_ dst) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrDup(SWIGTYPE_p_SnsrSession_.getCPtr(s), SWIGTYPE_p_p_SnsrSession_.getCPtr(dst)));
  }

  public static String snsrErrorDetail(SWIGTYPE_p_SnsrSession_ s) {
    return SnsrJNI.snsrErrorDetail(SWIGTYPE_p_SnsrSession_.getCPtr(s));
  }

  public static SnsrRC snsrForEach(SWIGTYPE_p_SnsrSession_ s, String key, SWIGTYPE_p_SnsrCallback_ c) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrForEach(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, SWIGTYPE_p_SnsrCallback_.getCPtr(c)));
  }

  public static SnsrRC snsrGetDouble(SWIGTYPE_p_SnsrSession_ s, String key, SWIGTYPE_p_double value) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrGetDouble(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, SWIGTYPE_p_double.getCPtr(value)));
  }

  public static SnsrRC snsrGetInt(SWIGTYPE_p_SnsrSession_ s, String key, SWIGTYPE_p_int value) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrGetInt(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, SWIGTYPE_p_int.getCPtr(value)));
  }

  public static SnsrRC snsrGetStream(SWIGTYPE_p_SnsrSession_ s, String key, SWIGTYPE_p_p_SnsrStream_ stream) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrGetStream(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, SWIGTYPE_p_p_SnsrStream_.getCPtr(stream)));
  }

  public static SnsrRC snsrGetString(SWIGTYPE_p_SnsrSession_ s, String key, SWIGTYPE_p_p_char value) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrGetString(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, SWIGTYPE_p_p_char.getCPtr(value)));
  }

  public static SnsrRC snsrLoad(SWIGTYPE_p_SnsrSession_ s, SWIGTYPE_p_SnsrStream_ inputStream) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrLoad(SWIGTYPE_p_SnsrSession_.getCPtr(s), SWIGTYPE_p_SnsrStream_.getCPtr(inputStream)));
  }

  public static SnsrRC snsrNewValidateVersion(SWIGTYPE_p_p_SnsrSession_ s, String version) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrNewValidateVersion(SWIGTYPE_p_p_SnsrSession_.getCPtr(s), version));
  }

  public static SnsrRC snsrRequire(SWIGTYPE_p_SnsrSession_ s, String key, String value) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrRequire(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, value));
  }

  public static SnsrRC snsrRun(SWIGTYPE_p_SnsrSession_ s) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrRun(SWIGTYPE_p_SnsrSession_.getCPtr(s)));
  }

  public static SnsrRC snsrRC(SWIGTYPE_p_SnsrSession_ s) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrRC(SWIGTYPE_p_SnsrSession_.getCPtr(s)));
  }

  public static String snsrRCMessage(SnsrRC returnCode) {
    return SnsrJNI.snsrRCMessage(returnCode.swigValue());
  }

  public static void snsrRetain(SWIGTYPE_p_void handle) {
    SnsrJNI.snsrRetain(SWIGTYPE_p_void.getCPtr(handle));
  }

  public static void snsrRelease(SWIGTYPE_p_void handle) {
    SnsrJNI.snsrRelease(SWIGTYPE_p_void.getCPtr(handle));
  }

  public static SnsrRC snsrSave(SWIGTYPE_p_SnsrSession_ s, SnsrDataFormat format, SWIGTYPE_p_SnsrStream_ outputStream) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrSave(SWIGTYPE_p_SnsrSession_.getCPtr(s), format.swigValue(), SWIGTYPE_p_SnsrStream_.getCPtr(outputStream)));
  }

  public static SnsrRC snsrSet(SWIGTYPE_p_SnsrSession_ s, String keyValue) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrSet(SWIGTYPE_p_SnsrSession_.getCPtr(s), keyValue));
  }

  public static SnsrRC snsrSetDouble(SWIGTYPE_p_SnsrSession_ s, String key, double value) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrSetDouble(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, value));
  }

  public static SnsrRC snsrSetHandler(SWIGTYPE_p_SnsrSession_ s, String key, SWIGTYPE_p_SnsrCallback_ c) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrSetHandler(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, SWIGTYPE_p_SnsrCallback_.getCPtr(c)));
  }

  public static SnsrRC snsrSetInt(SWIGTYPE_p_SnsrSession_ s, String key, int value) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrSetInt(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, value));
  }

  public static SnsrRC snsrSetStream(SWIGTYPE_p_SnsrSession_ s, String key, SWIGTYPE_p_SnsrStream_ stream) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrSetStream(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, SWIGTYPE_p_SnsrStream_.getCPtr(stream)));
  }

  public static SnsrRC snsrSetString(SWIGTYPE_p_SnsrSession_ s, String key, String value) {
    return SnsrRC.swigToEnum(SnsrJNI.snsrSetString(SWIGTYPE_p_SnsrSession_.getCPtr(s), key, value));
  }

  public static void setAssetManager(AssetManager mgr) {
    SnsrJNI.setAssetManager(mgr);
  }

}

/**
 * @}
 * java
 */

