/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 3.0.12
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package com.sensory.speech.snsr;

/**
 * @file
 * Return code for SnsrSession and SnsrStream.
 * @addtogroup java
 * @{
 */
/**
 * @addtogroup java-session
 * @{
 */
/**
 * Return code for SnsrSession and SnsrStream.
 * SnsrRC#OK for success, any other value indicates failure.
 */

public enum SnsrRC {
  /** Operation completed successfully. */
  OK,
  /** Cannot read or write past the end of the stream. */
  EOF,
  /** Operation failed. */
  ERROR,
  /** Stream is not open. */
  NOT_OPEN,
  /** Resource not found. */
  NOT_FOUND,
  /** Out of heap memory. */
  NO_MEMORY,
  /** Incorrect stream mode (read or write). */
  WRONG_MODE,
  /** Interrupted. */
  INTERRUPTED,
  /** Invalid argument. */
  INVALID_ARG,
  /** Invalid mode. */
  INVALID_MODE,
  /** Cannot re-open this stream. */
  CANNOT_REOPEN,
  /** The stream handle is invalid. */
  INVALID_HANDLE,
  /** Function is not implemented for this stream type. */
  NOT_IMPLEMENTED,
  /** Delimiter character not encountered. */
  DELIM_NOT_FOUND,
  /** Stream format is not supported. */
  FORMAT_NOT_SUPPORTED,
  /** Buffer overrun, stream not read from in time */
  BUFFER_OVERRUN,
  /** Buffer underrun, stream not written to in time. */
  BUFFER_UNDERRUN,
  /** _Invalid return code (RESERVED_A is not used)._ */
  RESERVED_A,
  /** Argument value is not in the valid range. */
  ARG_OUT_OF_RANGE,
  /** A channel with this name already exists in the bin. */
  CHANNEL_EXISTS,
  /** This channel is not backed by a circular buffer. */
  CHANNEL_NOT_BUFFERED,
  /** Channel not found. */
  CHANNEL_NOT_FOUND,
  /** Source and destination channel types are not compatible. */
  CHANNELS_NOT_COMPATIBLE,
  /** Element settings are inconsistent. */
  CONFIGURATION_INCONSISTENT,
  /** Element configuration is missing. */
  CONFIGURATION_MISSING,
  /** Connection not found. */
  CONNECTION_NOT_FOUND,
  /** Destination channel not found. */
  DST_CHANNEL_NOT_FOUND,
  /** Destination element is not in this bin. */
  DST_ELEMENT_NOT_IN_BIN,
  /** The destination port is already connected. */
  DST_PORT_IN_USE,
  /** Element ID is not known. */
  ELEMENT_ID_NOT_KNOWN,
  /** Element initialization failed. */
  ELEMENT_INIT_FAILED,
  /** Element initialization is incomplete. */
  ELEMENT_INIT_INCOMPLETE,
  /** Element is not a bin, function is not available. */
  ELEMENT_IS_NOT_A_BIN,
  /** Element is not in this bin. */
  ELEMENT_NOT_IN_BIN,
  /** Element is not the root bin, function is not available. */
  ELEMENT_NOT_ROOT_BIN,
  /** Element registration failed. */
  ELEMENT_REGISTRATION_FAILED,
  /** Setting is not of the correct type. */
  INCORRECT_SETTING_TYPE,
  /** License validation failed. */
  LICENSE_NOT_VALID,
  /** Push iteration limit exceeded. */
  ITERATION_LIMIT,
  /** Element API processing check failed. */
  ELEMENT_API_VIOLATION,
  /** Name is not unique for this bin. */
  NAME_NOT_UNIQUE,
  /** Buffer does not have enough free space. */
  NOT_ENOUGH_SPACE,
  /** Element has not been initialized. */
  NOT_INITIALIZED,
  /** Push failed. */
  PUSH_FAILED,
  /** Repeated by callback. */
  REPEAT,
  /** Setting could not be applied. */
  SETTING_FAILED,
  /** Setting is read-only. */
  SETTING_IS_READ_ONLY,
  /** Setting is not available in this context. */
  SETTING_NOT_AVAILABLE,
  /** Setting not found for this element. */
  SETTING_NOT_FOUND,
  /** Skipped by callback. */
  SKIP,
  /** Source channel not found. */
  SRC_CHANNEL_NOT_FOUND,
  /** Source element is not in this bin. */
  SRC_ELEMENT_NOT_IN_BIN,
  /** The source port is already connected. */
  SRC_PORT_IN_USE,
  /** Stopped by callback. */
  STOP,
  /** Stream operation failed. */
  STREAM,
  /** End-of-stream reached. */
  STREAM_END,
  /** Unknown configuration object type. */
  UNKNOWN_OBJECT_TYPE,
  /** Setting has no configured value. */
  VALUE_NOT_SET,
  /** _Invalid return code (RESERVED_B is not used)._ */
  RESERVED_B,
  /** No task model data found. */
  NO_MODEL,
  /** Task value does not match requirement. */
  REQUIRE_MISMATCH,
  /** Task version does not match the requirement. */
  VERSION_MISMATCH,
  /**
   * The header file version does not match that of the library.
   * SNSR_VERSION in snsr.h does not match the version the
   * library archive was compiled with. Check include paths.
   */
  LIBRARY_HEADER,
  /**
   * TrulyHandsfree library is too old.
   * Loading of a new task failed as it requires features that are not
   * available in this release of the library. Please contact Sensory for
   * assistance.
   * @see snsrLoad(), #SNSR_VERSION
   */
  LIBRARY_TOO_OLD,
  /** Operation timed out. */
  TIMED_OUT,;

  public final int swigValue() {
    return swigValue;
  }

  public static SnsrRC swigToEnum(int swigValue) {
    SnsrRC[] swigValues = SnsrRC.class.getEnumConstants();
    if (swigValue < swigValues.length && swigValue >= 0 && swigValues[swigValue].swigValue == swigValue)
      return swigValues[swigValue];
    for (SnsrRC swigEnum : swigValues)
      if (swigEnum.swigValue == swigValue)
        return swigEnum;
    throw new IllegalArgumentException("No enum " + SnsrRC.class + " with value " + swigValue);
  }

  @SuppressWarnings("unused")
  private SnsrRC() {
    this.swigValue = SwigNext.next++;
  }

  @SuppressWarnings("unused")
  private SnsrRC(int swigValue) {
    this.swigValue = swigValue;
    SwigNext.next = swigValue+1;
  }

  @SuppressWarnings("unused")
  private SnsrRC(SnsrRC swigEnum) {
    this.swigValue = swigEnum.swigValue;
    SwigNext.next = this.swigValue+1;
  }

  private final int swigValue;

  private static class SwigNext {
    private static int next = 0;
  }
}


/**
 * @}
 * java-session
 */

/**
 * @}
 * java
 */

