/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 3.0.12
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package com.sensory.speech.snsr;

/**
 * @file
 * SnsrStream audio format specifier.
 * @addtogroup java
 * @{
 */
/**
 * @addtogroup java-stream
 * @{
 */
/**
 * SnsrStream audio format specifier.
 * @see SnsrStream#fromAudioDevice(), SnsrStream#fromAudioStream().
 */

public enum SnsrStreamAudioFormat {
  /**
   * Read-only default audio stream format.
   */
  DEFAULT,

  /**
   * Read-only default audio stream format, low latency.
   * Low latency, at the expense of higher CPU overhead.
   */
  DEFAULT_LOW_LATENCY,

  /**
   * Read-only 16-bit little-endian LPCM at 16 kHz.
   */
  LPCM_S16_16K,

  /**
   * Read-only 16-bit little-endian LPCM at 16 kHz, low latency.
   * Low latency, at the expense of higher CPU overhead.
   */
  LPCM_S16_16K_LOW_LATENCY,

  /**
   * Read-only 16-bit little-endian LPCM with a user-specified device.
   * Expected args
   *   @code const char *device @endcode
   * Example:
   * @code
   * b = snsrStreamFromAudioDevice(DEVICE, "default");
   * @endcode
   */
  DEVICE,

  /**
   * Read-only 16-bit LE LPCM with a user-specified device, low latency.
   * Low latency, at the expense of higher CPU overhead.
   * Expected args
   *   @code const char *device @endcode
   * Example:
   * @code
   * b = snsrStreamFromAudioDevice(DEVICE_LOW_LATENCY, "default");
   * @endcode
   */
  DEVICE_LOW_LATENCY,

  /**
   * Read-only 16-bit LE LPCM, user-specified device, sample rate, and mode.
   * Expected args:
   *   @code const char *device, unsigned int rate, SnsrStreamMode mode @endcode
   *
   * Example:
   * @code
   * b = snsrStreamFromAudioDevice(DEVICE_RATE_MODE,
   *                               "default", 16000, SNSR_ST_MODE_READ);
   * @endcode
   */
  DEVICE_RATE_MODE,

  /**
   * Read-only 16-bit LE LPCM, device, rate, and mode. Low latency.
   * Low latency, at the expense of higher CPU overhead.
   *
   * Expected args:
   *   @code const char *device, unsigned int rate, SnsrStreamMode mode @endcode
   *
   * Example:
   * @code
   * b = snsrStreamFromAudioDevice(DEVICE_RATE_MODE_LOW_LATENCY,
   *                               "default", 16000, SNSR_ST_MODE_READ);
   * @endcode
   */
  DEVICE_RATE_MODE_LOW_LATENCY,

  /**
   * Read-only 16-bit little-endian LPCM with a user-specified device.
   * Expected args
   *   @code int devid @endcode
   *
   * @note On Windows, @c devid is the device ID used with
   * the Multimedia Extensions, such as [waveInGetDevCaps()][1].
   *
   * Example:
   * @code
   * b = snsrStreamFromAudioDevice(DEVID, 0);
   * @endcode
   *
   * [1]: https://msdn.microsoft.com/en-us/library/dd743841(v=vs.85).aspx
   */
  DEVID,

  /**
   * Read-only 16-bit LE LPCM with a user-specified device, low latency.
   * Low latency, at the expense of higher CPU overhead.
   * Expected args
   *   @code int devid @endcode
   *
   * @note On Windows, @c devid is the device ID used with
   * the Multimedia Extensions, such as [waveInGetDevCaps()][1].
   *
   * Example:
   * @code
   * b = snsrStreamFromAudioDevice(DEVID_LOW_LATENCY, 0);
   * @endcode
   *
   * [1]: https://msdn.microsoft.com/en-us/library/dd743841(v=vs.85).aspx
   */
  DEVID_LOW_LATENCY,

  /**
   * Read-only 16-bit LE LPCM, user-specified device, sample rate, and mode.
   * Expected args:
   *   @code int devid, unsigned int rate, SnsrStreamMode mode @endcode
   *
   * @note On Windows, @c devid is the device ID used with
   * the Multimedia Extensions, such as [waveInGetDevCaps()][1].
   *
   * Example:
   * @code
   * b = snsrStreamFromAudioDevice(DEVID_RATE_MODE,
   *                               0, 16000, SNSR_ST_MODE_READ);
   * @endcode
   *
   * [1]: https://msdn.microsoft.com/en-us/library/dd743841(v=vs.85).aspx
   */
  DEVID_RATE_MODE,

  /**
   * Read-only 16-bit LE LPCM, device, rate, and mode. Low latency.
   * Low latency, at the expense of higher CPU overhead.
   *
   * Expected args:
   *   @code int devid, unsigned int rate, SnsrStreamMode mode @endcode
   *
   * @note On Windows, @c devid is the device ID used with
   * the Multimedia Extensions, such as [waveInGetDevCaps()][1].
   *
   * Example:
   * @code
   * b = snsrStreamFromAudioDevice(DEVID_RATE_MODE_LOW_LATENCY,
   *                               0, 16000, SNSR_ST_MODE_READ);
   * @endcode
   *
   * [1]: https://msdn.microsoft.com/en-us/library/dd743841(v=vs.85).aspx
   */
  DEVID_RATE_MODE_LOW_LATENCY,;

  public final int swigValue() {
    return swigValue;
  }

  public static SnsrStreamAudioFormat swigToEnum(int swigValue) {
    SnsrStreamAudioFormat[] swigValues = SnsrStreamAudioFormat.class.getEnumConstants();
    if (swigValue < swigValues.length && swigValue >= 0 && swigValues[swigValue].swigValue == swigValue)
      return swigValues[swigValue];
    for (SnsrStreamAudioFormat swigEnum : swigValues)
      if (swigEnum.swigValue == swigValue)
        return swigEnum;
    throw new IllegalArgumentException("No enum " + SnsrStreamAudioFormat.class + " with value " + swigValue);
  }

  @SuppressWarnings("unused")
  private SnsrStreamAudioFormat() {
    this.swigValue = SwigNext.next++;
  }

  @SuppressWarnings("unused")
  private SnsrStreamAudioFormat(int swigValue) {
    this.swigValue = swigValue;
    SwigNext.next = swigValue+1;
  }

  @SuppressWarnings("unused")
  private SnsrStreamAudioFormat(SnsrStreamAudioFormat swigEnum) {
    this.swigValue = swigEnum.swigValue;
    SwigNext.next = this.swigValue+1;
  }

  private final int swigValue;

  private static class SwigNext {
    private static int next = 0;
  }
}


/**
 * @}
 * java-stream
 */

/**
 * @}
 * java
 */

